@echo off
setlocal EnableDelayedExpansion

echo Please wait. Searching for Keil PackUnzip.exe...

:reg_search

    reg query HKEY_CLASSES_ROOT\PACKFILE\Shell\open\command
    if ERRORLEVEL 1 goto:reg_search_failed

    for /f "tokens=3" %%a in ('reg query HKEY_CLASSES_ROOT\PACKFILE\Shell\open\command') do set "PACK_UNZIP=%%a"
    goto:reg_search_success

:reg_search_success
    choice /M "PackUnzip.exe was found in registry at %PACK_UNZIP%. Do you want to ignore this and search hard drive instead? (Recommended: 'N')"
    if ERRORLEVEL 2 goto:install
    if ERRORLEVEL 1 goto:manual_search
    goto:install

:reg_search_failed
    choice /M "PackUnzip.exe was not found in the registry. Do you want to search hard drive for PackUnzip.exe?"
    if ERRORLEVEL 2 goto:last_task
    if ERRORLEVEL 1 goto:manual_search
    goto:last_task

:manual_search

    echo.
    echo * Searching C:\ drive *
    set i=0
    for /r c:\ %%f in (*PackUnzip.exe) do (
        set /A i+=1
        set PACK_UNZIP_PATH[!i!]="%%f"

    )
    set FOUND_PACK_UNZIP_COUNT=%i%
    if %FOUND_PACK_UNZIP_COUNT% equ 0 (
        echo Cannot find Keil PackUnzip.exe...
        goto:last_task
    )
    set PACK_UNZIP_LOCATION_NUMBER=1

    if %FOUND_PACK_UNZIP_COUNT% gtr 1 (
        echo.
        echo * Found more than one PackUnzip.exe path: *
        echo.
        for /L %%i in (1, 1 %FOUND_PACK_UNZIP_COUNT%) do echo [%%i]: !PACK_UNZIP_PATH[%%i]!

        echo.
        echo * Packs will be installed only for Keil in the same location as selected PackUnzip.exe. *
        SET /P PACK_UNZIP_LOCATION_NUMBER="Please enter a number of PackUnzip.exe which should be used: "
    )

    set OR_RESULT=false
    if %PACK_UNZIP_LOCATION_NUMBER% lss 1 set OR_RESULT=true
    if %PACK_UNZIP_LOCATION_NUMBER% gtr %FOUND_PACK_UNZIP_COUNT% set OR_RESULT=true
    if %OR_RESULT% equ true (
        echo Selected wrong Keil PackUnzip.exe location.
        GOTO last_task
    )

    set PACK_UNZIP=!PACK_UNZIP_PATH[%PACK_UNZIP_LOCATION_NUMBER%]!

    goto:install

:install
    echo.
    echo * Selected Keil PackUnzip.exe location: %PACK_UNZIP% *

    echo.
    echo * Installing all Packs... *
    for /r "%cd%" %%f in (*.pack) do (
        echo Installing... "%%f"
        %PACK_UNZIP% "%%f" --no-gui 2>NUL
    )

    echo.
    echo * Installation done *

    goto:pause

:last_task
    echo.
    echo * Installation failed *

:pause
    pause